# Gophi

A server with Gopher & Gemini protocol support in GoLang!

Unix (like) OSes only. Cross-compiled to way too many architectures.
Build-script now much improved, but still not pretty...

I work on open-source projects like this and many others for
free. If you would like to help support my work that would be hugely
appreciated 💕 [donate here](https://liberapay.com/grufwub/)

Binary releases at:

- `gemini://iim.gay/files/gophi/`

- `gopher://iim.gay/1/files/gophi/`

For now, Gophi compilation is reliant on a version of Go that has latest POSIX
syscall fixes cherry picked, e.g. [my fork](https://github.com/grufwub/go/tree/go1.15.5-posix-syscall-fix)

# Features

- Built with security, concurrency and efficiency in mind

- LRU file caching with user-controlled cache size, max cached file size,
  refresh frequency and max file age before being marked as stale

- Buffer pools to minimize allocations

- CGI/1.1 support

- URL encoding with query support

- Path access restrictions with regex (see [usage](docs/USAGE.md))

- Request remapping with regex (see [usage](docs/USAGE.md))

- User server spaces (see [usage](docs/USAGE.md))

- Separate system and access logging

- Chroot and dropping permissions to provided user+group (see [extra notes](docs/MISC.md)
  for why you may want to do this over manually executing binary in a chroot)

- Only 1 external dependency, `go-toml` brought in by my own `go-config`
  library

# Further Docs

[Usage](docs/USAGE.md)

[Example Configuration](docs/example.toml)

[CGI compliance](docs/CGI.md)

[Gopher specific information](docs/GOPHER.md)

[Gemini specific information](docs/GEMINI.md)

[Extra notes](docs/MISC.md)

# Future plans

- improve the build scripts...

- gemini vhosts

- chroot setup script

- Gemini enforce TLS client validity / certificate zones

- SCGI