package core

// Error string constants
const (
	connWriteErrStr      = "Conn write error"
	connReadErrStr       = "Conn read error"
	connCloseErrStr      = "Conn close error"
	listenerBeginErrStr  = "Listener begin error"
	listenerAcceptErrStr = "Listener accept error"
	mutexUpgradeErrStr   = "Mutex upgrade fail"
	mutexDowngradeErrStr = "Mutex downgrade fail"
	fileOpenErrStr       = "File open error"
	fileStatErrStr       = "File stat error"
	fileReadErrStr       = "File read error"
	fileTypeErrStr       = "Unsupported file type"
	directoryReadErrStr  = "Directory read error"
	restrictedPathErrStr = "Restricted path"
	invalidHostErrStr    = "Invalid host"
	invalidRequestErrStr = "Invalid request"
	cgiStartErrStr       = "CGI start error"
	cgiExitCodeErrStr    = "CGI non-zero exit code"
)

// Log string constants
const (
	hostnameBindEmptyStr = "At least one of 'hostname' or 'listen' must be non-empty!"

	chrootStr    = "Chrooting into dir: %s"
	chrootErrStr = "Error chrooting into directory: %s"

	chDirStr    = "Entered server dir: %s"
	chDirErrStr = "Error entering server directory: %s"

	rootDirEmptyErrStr = "No server root directory supplied!"

	userLookupErrStr        = "Error looking up user: %s"
	groupLookupErrStr       = "Error looking up group: %s"
	currentUserLookupErrStr = "Error looking up current user: %s"

	setuidStr    = "Running as user: %s"
	setuidErrStr = "Error performing setuid: %s"

	setgidStr    = "Running as group: %s"
	setgidErrStr = "Error performing setgid: %s"

	runningAsRootErrStr = "Gophi does not support running as root!"

	listenerBeginFailStr = "Failed to start listener on %s://%s:%s (%s:%s) - %s"
	listeningOnStr       = "Listening on %s://%s:%s (%s:%s)"

	cacheMonitorStartStr = "Starting cache monitor with freq: %s"
	cacheFileStatErrStr  = "Failed to stat file in cache: %s"

	pathRestrictionsEnabledStr      = "Path restrictions enabled"
	pathRestrictionsDisabledStr     = "Path restrictions disabled"
	pathRestrictRegexCompileFailStr = "Failed compiling restricted path regex: %s"
	pathRestrictRegexCompiledStr    = "Compiled restricted path regex: %s"

	pathHidingEnabledStr          = "Path hiding enabled"
	pathHidingDisableStr          = "Path hiding disabled"
	pathHidingRegexCompileFailStr = "Failed compiling hidden path regex: %s"
	pathHidingRegexCompiledStr    = "Compiled hidden path regex: %s"

	requestRemapEnabledStr          = "Request remapping enabled"
	requestRemapDisabledStr         = "Request remapping disabled"
	requestRemapRegexInvalidStr     = "Invalid request remap regex: %s"
	requestRemapRegexCompileFailStr = "Failed compiling request remap regex: %s"
	requestRemapRegexCompiledStr    = "Compiled path remap regex: %s"
	requestRemappedStr              = "Remapped request: %s %s"

	cgiPathStr            = "CGI safe path: %s"
	cgiSupportEnabledStr  = "CGI script support enabled"
	cgiSupportDisabledStr = "CGI script support disabled"
	cgiDirNotRelativeStr  = "CGI directory must be a relative path!"
	cgiDirStr             = "CGI directory: %s"
	cgiExecuteErrStr      = "Exit executing: %s [%d]"

	userSpacesEnabledStr  = "User spaces support enabled"
	userSpacesDisabledStr = "User spaces support disabled"
	userSpacesStr         = "User space directory: %s"

	signalReceivedStr = "Signal received: %v. Shutting down..."

	logOutputErrStr = "Error opening log output %s: %s"
)
