# CGI/1.1 Compliance

The list of environment variables that gophi sets are as follows.

```
# Both
GATEWAY INTERFACE        | "CGI/1.1"
SERVER_SOFTWARE          | "gophi" + protocol + version
SERVER_PROTOCOL          | protocol
SERVER_NAME              | server hostname
SERVER_PORT              | server listening port
REMOTE_ADDR              | client ip
QUERY_STRING             | request query string
SCRIPT_NAME              | script relative path
SCRIPT_FILENAME          | script absolute path
PATH_INFO                | remainder of URI's path after selector
DOCUMENT_ROOT            | server root directory
REQUEST_URI              | request URI (i.e. selector)

# Gopher specific
COLUMNS                  | no. columns server is configured for

# Gemini specific
GEMINI_URL               | full gemini url (including hostname, port, scheme)
TLS_CIPHER               | TLS cipher in use
TLS_VERSION              | TLS version in use
AUTH_TYPE                | "Certificate" when client certs found
REMOTE_USER              | TLS client cert subject common name
TLs_CLIENT_HASH          | TLS client cert sha256 hash ("SHA256:______")
TLS_CLIENT_NOT_BEFORE    | TLS client cert not before date
TLS_CLIENT_NOT_AFTER     | TLS client cert not after date
TLS_CLIENT_ISSUER        | TLS client cert issuer
TLS_CLIENT_SUBJECT       | TLS client cert subject
TLS_CLIENT_VERIFIED      | TLS client cert validity, ("SUCCESS" or "FAIL:<error string>")
```