package gemini

import (
	"gophi/core"
)

const gemMimeType = "text/gemini"

func getFileStatusMeta(p *core.Path) string {
	// if this is a gem, return this
	if isGem(p) {
		return gemMimeType
	}

	// Get file extension
	ext := core.FileExt(p.Relative())

	// Try get the mime type, or use default unknown (application octet-stream)
	mimeType, ok := mimeTypes[ext]
	if !ok {
		mimeType = "application/octet-stream"
	}

	// Calculate mime type for extension
	return mimeType
}

func buildRedirect(to string) []byte {
	return buildResponseHeader("31", to)
}

func buildResponseHeader(statusCode, statusMeta string) []byte {
	return []byte(statusCode + " " + statusMeta + "\r\n")
}
