package gemini

import (
	"gophi/core"
	"regexp"
)

var (
	// gemRegex is the precompiled gemini file name regex check
	gemRegex = regexp.MustCompile(`^(|.+/|.+\.)gmi$`)
)

// isGem checks against gemini regex as to whether a file path is a gemini file
func isGem(path *core.Path) bool {
	return gemRegex.MatchString(path.Relative())
}
